require 'uri'

Then /^I should see this status:$/ do |table|
  Synchronization::wait_until do
    page.evaluate_script('$.active') == 0
  end
  cols = table.transpose.raw
  cols.each do |row|
    title = row.shift
    all(:xpath, "//div[@id='filter_result']/table/tbody/tr/td[count(preceding-sibling::td) = count(../../../thead[position()=last()]/tr/th[contains(.,'" + title + "')]/preceding-sibling::th)]").each do |col|
      expected = row.shift
      col.should have_content expected
    end
    row.length.should be == 0
  end
end

Then /^the filter result table should have (\d+) rows$/ do |numrows|
  Synchronization::wait_until do
    page.evaluate_script('$.active') == 0
  end
  page.all('div#filter_result table tbody tr').count == numrows.to_i
end

When /^I am on the "(.*?)" listview$/ do |arg1|
  visit("https://#{SERVER}/monitor/index.php/listview?q=" + URI::escape(arg1))
end

When /^I sort the filter result table by "(.*?)"$/ do |arg1|
  Synchronization::wait_until do
    page.evaluate_script('$.active') == 0
  end
  page.find("div#filter_result table thead:first-child th[data-column=#{arg1}]").trigger(:click)
end

Then /^The (.*?) row of the filter result table should contain "(.*?)"$/ do |pos, str|
  Synchronization::wait_until do
    page.evaluate_script('$.active') == 0
  end
  within(:css, "div#filter_result table tbody tr:#{pos}-child") do
    page.should have_content(str)
  end
end

Then /^the listview should be empty$/ do
  Synchronization::wait_until do
    page.evaluate_script('$.active') == 0
  end
  page.should have_content("No entries found using filter")
end

When /I select "(.*)" from the multiselect "(.*)"$/ do |option, selector|
  tmp_sel = find_field(find_field(selector)[:id].sub('[', '_tmp['))
  tmp_sel.select(option)
  page.execute_script("$('##{tmp_sel[:id].gsub('[', '\\\\\[').gsub(']', '\\\\\]')}').trigger('change');")
end

When /I deselect "(.*)" from the multiselect "(.*)"$/ do |option, selector|
  tmp_sel = find_field(selector)
  tmp_sel.select(option)
  page.execute_script("$('##{tmp_sel[:id].gsub('[', '\\\\\[').gsub(']', '\\\\\]')}').trigger('change');")
end

When /^I filter "(.*)" on "(.*)"$/ do |selector, regex|
  find(:xpath, ".//input[following-sibling::*[self::input | self::textarea | self::select][not(./@type = 'submit' or ./@type = 'image' or ./@type = 'hidden')][(((./@id = '#{selector}' or ./@name = '#{selector}') or ./@placeholder = '#{selector}') or ./@id = //label[normalize-space(string(.)) = '#{selector}']/@for)]]").set(regex)
end

Then /^I should see a notification$/ do
  Synchronization::wait_until do
    page.all('div.notify-notification').count > 0
  end
end

Then /^waiting until I see (?:([\d]+) )?"([^"]*)"$/ do |n, string|
  Synchronization::wait_until do
    page.should have_content(string, :count => n)
  end
end


Then /^I should see (a|an) (error|info|success|warning) notification$/ do |ignore, type|
  Synchronization::wait_until do
    page.all("div.notify-notification.#{type}").count > 0
  end
end

And /^the notification should contain "([^\"]*)"$/ do |notification_text|
  page.find('div.notify-notification').should have_content(notification_text)
end

Then /^I should see a notification containing the text "([^\"]*)"$/ do |notification_text|
  steps %Q{
    Then I should see a notification
    And the notification should contain "#{notification_text}"
  }
end

Then /^I should see (?:a|an) (error|info|success|warning) notification containing the text "([^\"]*)"$/ do |type, notification_text|
  page.should(have_selector("div.notify-notification.#{type}", text: /#{notification_text}/))
end

When /^I reload the page$/ do
  visit current_url
end
